class Base {
	// base class, updates worlds, etc.
	//
	// To store the interval number for updates
	private static var interval:Number;
	// the currently updating world
	public var currentWorld:World;
	// last update time
	public var last:Number;
	// debug
	public var aT:Array;
	// for pausing
	private var bPlay:Boolean = false;
	
	function Base() {
		// There should really only be one base at any given time.
		// If somehow, another base is created, and the interval from the previous base is still there,
		// this kills the interval.
		if (Base.interval != null) {
			clearInterval(Base.interval);
			Base.interval = null;
		}
		this.aT = [];
	}
	
	// properties

	function get playing():Boolean {
		return this.bPlay;
	}

	// methods
	
	function play() {
		if (Base.interval == null) {
			this.bPlay = true;
			this.last = getTimer();
			Base.interval = setInterval(function(o) {o.update()}, 0, this);
		}
	}
	
	function pause() {
		if (Base.interval != null) {
			this.bPlay = false;
			clearInterval(Base.interval);
			Base.interval = null;
		}
	}
	
	function update(o) {
		var nCurrent = getTimer();
		var nElapsed = (nCurrent - this.last)/1000;
		this.currentWorld.update(nElapsed);
		this.last = nCurrent;
		if (this.aT.length > 4) {
			var t;
			t = 0;
			for (var i=0;i<this.aT.length;++i) {
				t = t + this.aT[i];
			}
			_root.nDebug0 = t/this.aT.length;
			this.aT = [];
		}
		this.aT.push(nElapsed);
	}
	
	function setWorld(oWorld:World) {
		if (oWorld != null) {
			this.currentWorld.onExit();
			this.currentWorld = oWorld;
			this.currentWorld.onEnter();
		} else {
			trace("Base received null for setWorld");
		}
	}
	
	static function hey() {
		trace("Hey!");
	}
}